//VITGLCanvas.cpp - GL canvas to do stuff in.

#include "wx\wxprec.h"

#ifndef WX_PRECOMP
#include "wx\wx.h"
#endif

#include "VITGLCanvas.h"

#include <cmath>

//using namespace std;
BEGIN_EVENT_TABLE(VITGLCanvas, wxGLCanvas)	
	EVT_CHAR(VITGLCanvas::OnKeyDown)
END_EVENT_TABLE()

VITGLCanvas::VITGLCanvas(wxWindow *parent, wxSize& size):
wxGLCanvas(parent, -1, wxPoint(0, 0), size),
startUp(false), type(0)
{
	
}

void VITGLCanvas::initGL()
{
	int i, j, k;
	float u[4];
	float v[4];
	float thing = 16.0f;
	float index_x = 0.0f;
	float index_y = 0.0f;
	float R = 1.0f;

    SetCurrent();

    // set viewing projection
    glMatrixMode(GL_PROJECTION);
    glFrustum(-0.5f, 0.5f, -0.5f, 0.5f, 1.0f, 3.0f);

    // position viewer
    glMatrixMode(GL_MODELVIEW);
    glTranslatef(0.0f, 0.0f, -2.5f);

    glRotatef(1.0f, 1.0f, 0.0f, 0.0f);

    glEnable(GL_DEPTH_TEST);
    //glEnable(GL_LIGHTING);
    //glEnable(GL_LIGHT0);

	k=0;
	for(i=0;i<thing;i++)
	{
		for(j=0;j<thing;j++)
		{
			u[0] = i * 360 / thing;
			v[0] = 90 - j * 180 / thing;
			u[1] = fmod((i+1),thing) * 360 / thing;
			v[1] = 90 - j * 180 / thing;
			u[2] = fmod((i+1),thing) * 360 / thing;
			v[2] = 90 - fmod((j+1),thing) * 180 / thing;
			u[3] = i * 360 / thing;
			v[3] = 90 - fmod((j+1),thing) * 180 / thing;
			vertexArray[k].set(R*cos(u[0])*cos(v[0]),
							   R*cos(u[0])*sin(v[0]),
							   R*sin(u[0]));
			k++;
			vertexArray[k].set(R*cos(u[1])*cos(v[1]),
							   R*cos(u[1])*sin(v[1]),
							   R*sin(u[1]));
			k++;
			vertexArray[k].set(R*cos(u[2])*cos(v[2]),
							   R*cos(u[2])*sin(v[2]),
							   R*sin(u[2]));
			k++;
			vertexArray[k].set(R*cos(u[3])*cos(v[3]),
							   R*cos(u[3])*sin(v[3]),
							   R*sin(u[3]));
			k++;
		}
	}

	/*for(j=0;j<(thing*4);j++)
	{
		vertexArray[j].set(cos(index_x*2.0f*3.1415926535897932384626433832795f),
						   sin(index_y*2.0f*3.1415926535897932384626433832795f),
						   0.0f);
		vertexArray[(j+2)].set(cos(index_x*2.0f*3.1415926535897932384626433832795f),
						   sin(index_y*2.0f*3.1415926535897932384626433832795f),
						   -10.0f);
		index_x += 1.0f/thing;
		index_y += 1.0f/thing;
		j++;
		vertexArray[j].set(cos(index_x*2.0f*3.1415926535897932384626433832795f),
						   sin(index_y*2.0f*3.1415926535897932384626433832795f),
						   0.0f);
		vertexArray[(j+2)].set(cos(index_x*2.0f*3.1415926535897932384626433832795f),
						   sin(index_y*2.0f*3.1415926535897932384626433832795f),
						   -10.0f);
		index_x += 1.0f/thing;
		index_y += 1.0f/thing;
		j++;
		j++;
	}*/
}

void VITGLCanvas::render()
{
	int i;
	float thing = 16.0f;

    if(!GetContext())
		return;

    SetCurrent();
    // Init OpenGL once, but after SetCurrent
    if (!startUp)
    {
        initGL();
        startUp = true;
    }

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glFrustum(-0.5f, 0.5f, -0.5f, 0.5f, 1.0f, 3.0f);
    glMatrixMode(GL_MODELVIEW);

    // clear color and depth buffers
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

    glRotatef(1.0f, 1.0f, 0.0f, 0.0f);

    // draw six faces of a cube
	if(!type)
		glBegin(GL_LINE_STRIP);
	else if(type == 1)
		glBegin(GL_LINES);
	else if(type == 2)
		glBegin(GL_POINTS);
	else if(type == 3)
		glBegin(GL_QUADS);
        for(i=0;i<(thing*(thing*4));i++)
		{
			/*glNormal3f(normalArray[i].x,
					   normalArray[i].y,
					   normalArray[i].z);*/
			glColor3f(fabs(vertexArray[i].x),
					  fabs(vertexArray[i].y),
					  fabs(vertexArray[i].z));
			glVertex3f(vertexArray[(i/*4*/)].x,
					   vertexArray[(i/*4*/)].y,
					   vertexArray[(i/*4*/)].z);
			/*glVertex3f(vertexArray[(i*4)+1].x,
					   vertexArray[(i*4)+1].y,
					   vertexArray[(i*4)+1].z);
			glVertex3f(vertexArray[(i*4)+2].x,
					   vertexArray[(i*4)+2].y,
					   vertexArray[(i*4)+2].z);
			glVertex3f(vertexArray[(i*4)+3].x,
					   vertexArray[(i*4)+3].y,
					   vertexArray[(i*4)+3].z);*/
		}
    glEnd();

    glFlush();
    SwapBuffers();
}

void VITGLCanvas::OnKeyDown(wxKeyEvent &event)
{
	if(event.GetKeyCode() == WXK_SPACE)
	{
		type++;
		if(type > 3)
			type = 0;
	}
	else
		event.Skip();
}
