//VITGLCanvas.h - GL canvas to do stuff in.

#ifndef VITGLCANVAS_H_
#define VITGLCANVAS_H_

#include "wx/glcanvas.h"

typedef struct _vertex
{
	float x;
	float y;
	float z;

	void set(float _x, float _y, float _z)
	{
		x = _x;
		y = _y;
		z = _z;
	};
} Vertex;

class VITGLCanvas : public wxGLCanvas
{
  public:
	VITGLCanvas(wxWindow *parent, wxSize& size);
	~VITGLCanvas() {};

	void initGL();
	void render();

	void OnKeyDown(wxKeyEvent& event);
  private:
	bool startUp;

	int type;

	enum
	{
		NUM_VERTICES = 1024,
	};

	Vertex vertexArray[NUM_VERTICES];
	Vertex normalArray[(NUM_VERTICES/4)];

	DECLARE_EVENT_TABLE()
};

#endif
